/**
 * Created by johnson.zhi on 2017/11/10.
 */

package org.nativeapi;

import java.lang.reflect.Field;
import java.util.List;
import org.cocos2dx.javascript.CocosActivity;
import org.cocos2dx.javascript.CocosActivityUtils;
import org.json.JSONObject;
import com.baidu.mobads.AdView;
import com.baidu.mobads.AdViewListener;
import com.eachbaby.Setting;
import android.annotation.SuppressLint;
import android.content.Context;
import android.content.Intent;
import android.os.Handler;
import android.os.Message;
import android.util.DisplayMetrics;
import android.util.Log;
import android.view.Gravity;
import android.view.View;
import android.view.ViewGroup;
import android.view.WindowManager;
import android.widget.AbsoluteLayout;
import android.widget.Button;
import android.widget.LinearLayout;

//第二套广告方案:一次性创建所有的广告,按需显示

public class Ad2 extends APIBase
{
	final String TAG="AD2";
	CocosActivity thisCocosActivity=null;	
	public String BaiduMSSP_AppID=null,BaiduMSSP_BannerID=null;
	public Ad2(CocosActivity cocosActivity) {
		super(cocosActivity);
		thisCocosActivity = cocosActivity;
		try {
			Field fAppSID=Setting.class.getDeclaredField("SDK_Baidu_MSSP_APPSID");
			Field fBannerID=Setting.class.getDeclaredField("SDK_Baidu_MSSP_BANNERID");			
			BaiduMSSP_AppID=(String)fAppSID.get(new Setting());
			BaiduMSSP_BannerID=(String)fBannerID.get(new Setting());			
			AdView.setAppSid(cocosActivity, BaiduMSSP_AppID);
			initAdBanner(BaiduMSSP_BannerID,measureAdBannerSize(0.25f));
			showAdBanner(false);
		} catch (Exception e) {
			BaiduMSSP_AppID=null;
			BaiduMSSP_BannerID=null;
		}
	}
	Handler mHandler=new Handler(){
       @Override
        public void handleMessage(Message msg) {
           super.handleMessage(msg);
	   		if(adViewU!=null)
				adViewU.setVisibility(msg.what==1?View.VISIBLE:View.INVISIBLE);
			if(adViewD!=null)
				adViewD.setVisibility(msg.what==2?View.VISIBLE:View.INVISIBLE);
			if(adViewL!=null)
				adViewL.setVisibility(msg.what==4?View.VISIBLE:View.INVISIBLE);//说明:ios中把左右搞反了,为了对课件保持一致,安卓也只能这样
			if(adViewR!=null)
				adViewR.setVisibility(msg.what==3?View.VISIBLE:View.INVISIBLE);//说明:ios中把左右搞反了,为了对课件保持一致,安卓也只能这样
        }
	};
	static class ADSize{
		public int width,height;
		ADSize(int w,int h){
			width=w;
			height=h;
		}
		public int getWidth(){
			return width;
		}
		public int getHeight(){
			return height;
		}
	}
	

	AdView adViewU=null,adViewD=null,adViewL=null,adViewR=null;
	AbsoluteLayout adContainerLayout=null;

	private void initAdBanner(String adPlaceId, ADSize adBannerSize) {
		ADSize winSize=getScreenSize();
		int x=0,y=0;

        //创建百度广告条
		adViewU = new AdView(thisCocosActivity, adPlaceId);
		x=winSize.getWidth()/2-adBannerSize.getWidth()/2;
		y=0;
		adViewU.setLayoutParams(new AbsoluteLayout.LayoutParams(adBannerSize.getWidth(),adBannerSize.getHeight(),x,y));
		
		x=winSize.getWidth()/2-adBannerSize.getWidth()/2;
		y=winSize.getHeight()-adBannerSize.getHeight();
		adViewD = new AdView(thisCocosActivity, adPlaceId);
		adViewD.setLayoutParams(new AbsoluteLayout.LayoutParams(adBannerSize.getWidth(),adBannerSize.getHeight(),x,y));
		
		adViewL = new AdView(thisCocosActivity, adPlaceId);
		adViewL.setRotation(-90);
		x=-(int)(adBannerSize.getWidth()*0.45);
		y=(winSize.getHeight()-adBannerSize.getHeight())/2;
		adViewL.setLayoutParams(new AbsoluteLayout.LayoutParams(adBannerSize.getWidth(),adBannerSize.getHeight(),x,y));
		
		adViewR = new AdView(thisCocosActivity, adPlaceId);
		adViewR.setRotation(-90);
		x=winSize.getWidth()-(int)(adBannerSize.getWidth()*0.6);
		y=(winSize.getHeight()-adBannerSize.getHeight())/2;
		adViewR.setLayoutParams(new AbsoluteLayout.LayoutParams(adBannerSize.getWidth(),adBannerSize.getHeight(),x,y));

		
		//显示容器
		adContainerLayout = new AbsoluteLayout(thisCocosActivity);
		adContainerLayout.addView(adViewU);
		adContainerLayout.addView(adViewD);
		adContainerLayout.addView(adViewL);
		adContainerLayout.addView(adViewR);
		thisCocosActivity.GetFrameLayout().addView(adContainerLayout);        
		
		
		//奇怪的问题:绝对布局里面如果只有一个元件,有时显示不出来,所以用代码给边上放一个几乎看不到的按钮
        Button btn = new Button(thisCocosActivity);
        btn.setText("b");
        AbsoluteLayout.LayoutParams layoutParams=new AbsoluteLayout.LayoutParams(2,2,0,0);
        btn.setLayoutParams(layoutParams);               
        adContainerLayout.addView(btn);  
        
        // 设置监听器
		AdViewListener listener=new AdViewListener() {
            @Override
            public void onAdSwitch() {
                Log.w(TAG, "onAdSwitch");
            }

            @Override
            public void onAdShow(JSONObject info) {
                // 广告已经渲染出来
                Log.w(TAG, "onAdShow " + info.toString());
            }

            @Override
            public void onAdReady(AdView adView) {
                // 资源已经缓存完毕，还没有渲染出来
                Log.w(TAG, "onAdReady " + adView);
            }
            @Override
            public void onAdFailed(String reason) {
            	/*
                Log.w("", "onAdFailed " + reason);
                RelativeLayout.LayoutParams rllp = new RelativeLayout
                        .LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.WRAP_CONTENT);
                rllp.addRule(RelativeLayout.CENTER_IN_PARENT);
                yourOriginalLayout.addView(mNoDataView, rllp);
*/            
            }

            @Override
            public void onAdClick(JSONObject info) {
                // Log.w(TAG, "onAdClick " + info.toString());
            }

            @Override
            public void onAdClose(JSONObject arg0) {
                Log.w(TAG, "onAdClose");
            }
        };
        adViewU.setListener(listener);
        adViewD.setListener(listener);
        adViewL.setListener(listener);
        adViewR.setListener(listener);
    }
	int adbarIndex=1;
	int adbarShow=1;
    private void showAdBanner(boolean show){
    	adbarShow=show?1:0;
		Message msg=new Message();
		msg.what=adbarIndex*adbarShow;
		mHandler.sendMessage(msg);
    }
    private void setAdBannerPos(String posAlign){
    	Message msg=new Message(); 
    	switch(posAlign){
	    	case "up":
	    		adbarIndex=1;
	    		break;
	    	case "down":
	    		adbarIndex=2;
	    		break;
	    	case "left":
	    		adbarIndex=3;
	    		break;
	    	case "right":
	    		adbarIndex=4;
	    		break;
    	}
		msg.what=adbarIndex*adbarShow;
		mHandler.sendMessage(msg);    	
    }
    ADSize getScreenSize(){
        DisplayMetrics dm = new DisplayMetrics();
        ((WindowManager) thisCocosActivity.getSystemService(Context.WINDOW_SERVICE)).getDefaultDisplay().getMetrics(dm);
        int winW = Math.max(dm.widthPixels,dm.heightPixels);
        int winH = Math.min(dm.widthPixels,dm.heightPixels);
        Log.d(TAG, "winW:"+winW+" winH:"+winH);
        return new ADSize(winW,winH);    	
    }
    ADSize measureAdBannerSize(float sizeScale){
    	ADSize winSize=getScreenSize();
		int width = (int) (winSize.width * sizeScale);
		int height = width * 3 / 20;
		Log.d(TAG, "adW:"+width+" adH:"+height);
        return new ADSize(width,height);
    }
	@Override
	public String onRequest(String command,List<String> params,String fullParam,APIBase.JSPipelineMessager messager) {
        switch(command){
        case "Test":
        	CocosActivityUtils.getInstance().showToast(fullParam);
        	messager.sendMessage("00000",params.get(0)+params.get(1));
        	return "";
        case "enableBanner":
        	showAdBanner(true);
        	setAdBannerPos(params.get(0));
        	break;
        case "disableBanner":
        	showAdBanner(false);
        	break;
        case "queryPopAd":
        	break;
        }
        return null;
	}
	@Override
	public void onPause() {
	}
	@Override
	public void onResume() {
	}
	@Override
	public void onActivityResult(int requestCode, int resultCode, Intent data) {
		// TODO Auto-generated method stub		
	}
	
}
